<!DOCTYPE html>

<html lang="en" data-content_root="../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>birdshot package &#8212; birdshot 0.0.post1.dev20+g168d24e.d20231220 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../_static/alabaster.css?v=233b9934" />
    <script src="../_static/documentation_options.js?v=c5a7b33d"></script>
    <script src="../_static/doctools.js?v=888ff710"></script>
    <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="prev" title="birdshot" href="modules.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="birdshot-package">
<h1>birdshot package<a class="headerlink" href="#birdshot-package" title="Link to this heading">¶</a></h1>
<section id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Link to this heading">¶</a></h2>
</section>
<section id="module-birdshot.birdshot">
<span id="birdshot-birdshot-module"></span><h2>birdshot.birdshot module<a class="headerlink" href="#module-birdshot.birdshot" title="Link to this heading">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">birdshot.birdshot.</span></span><span class="sig-name descname"><span class="pre">Birdshot</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">username</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">password</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">*</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">url</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot" title="Link to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">GDrive</span></code></p>
<dl class="py class">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">Entry</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">metadata</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Dict" title="(in Python v3.11)"><span class="pre">Dict</span></a><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">{}</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry" title="Link to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">Entry</span></code>, <code class="xref py py-class docutils literal notranslate"><span class="pre">BaseModel</span></code></p>
<p>The eponymous Entry is a file or folder inside a FileSystem, including
Google Drive. This class extends the functionality of the Entry to
interact with data stored in Google Drive as part of the Birdshot
program.</p>
<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.apply_to_properties">
<span class="sig-name descname"><span class="pre">apply_to_properties</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fn</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Callable" title="(in Python v3.11)"><span class="pre">Callable</span></a></span></em>, <em class="sig-param"><span class="o"><span class="pre">*</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">suffix</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">include</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">exclude</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cast</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/functions.html#type" title="(in Python v3.11)"><span class="pre">type</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">raise_on_error</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/functions.html#bool" title="(in Python v3.11)"><span class="pre">bool</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">replace</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/functions.html#bool" title="(in Python v3.11)"><span class="pre">bool</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fallback</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Callable" title="(in Python v3.11)"><span class="pre">Callable</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.apply_to_properties"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.apply_to_properties" title="Link to this definition">¶</a></dt>
<dd><p>Apply a callable to the list of properties.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>fn</strong> (<em>Callable</em>) – Function-like object that accepts an unordered list of values.</p></li>
<li><p><strong>suffix</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><em>str</em></a><em> (</em><em>optional</em><em>)</em>) – An optional string to append to the property key name when
storing the results of the function operation. Default: None;
that is, the result of the operation overwrites the property by
default.</p></li>
<li><p><strong>include</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><em>str</em></a><em> (</em><em>optional</em><em>)</em>) – A regular expression can be used to include specific (matching)
properties. Default: Include all properties.</p></li>
<li><p><strong>exclude</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><em>str</em></a><em> (</em><em>optional</em><em>)</em>) – A regular expression can be used to exclude specific (matching)
properties. See examples. Default: Exclude no properties.</p></li>
<li><p><strong>cast</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/functions.html#type" title="(in Python v3.11)"><em>type</em></a><em> (</em><em>optional</em><em>)</em>) – Cast the values to a specific type.</p></li>
<li><p><strong>default</strong> (<em>Any</em><em> (</em><em>optional</em><em>)</em>) – If not None, use this, the default value, if the cast fails. If
default = None and the cast fails, the value is returned
unchanged.</p></li>
<li><p><strong>raise_on_error</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/functions.html#bool" title="(in Python v3.11)"><em>bool</em></a><em> (</em><em>optional</em><em>)</em>) – If False (default), then any operation failure that raises an
exception excludes that property from the set of results. If
True, then no changes are made to the set of properties if an
error occurs while applying the operation.</p></li>
<li><p><strong>replace</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/functions.html#bool" title="(in Python v3.11)"><em>bool</em></a><em> (</em><em>optional</em><em>)</em>) – If False (default), then the result of the function updates the
the set of properties. If True, then the result of the function
replaces the existing properties.</p></li>
<li><p><strong>fallback</strong> (<em>callable</em><em> (</em><em>optional</em><em>)</em>) – Function to call should the first fail.</p></li>
</ul>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>None</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p># Initiate “entry”, an instance of Birdshot.Entry, with
# numerical properties.</p>
<p># The following performs a series of reductions, but excludes
# previously calculated values with the suffix “_.*”
entry.apply_to_properties(np.mean, suffix=”_mean”, exclude=”_.*”)
entry.apply_to_properties(np.std, suffix=”_std”, exclude=”_.*”)</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.central_tendency">
<span class="sig-name descname"><span class="pre">central_tendency</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.central_tendency"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.central_tendency" title="Link to this definition">¶</a></dt>
<dd><p>Automatically identify the central tendency in order: mean, mode</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.drop">
<span class="sig-name descname"><span class="pre">drop</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.drop"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.drop" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.inner_quartile_range">
<span class="sig-name descname"><span class="pre">inner_quartile_range</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.inner_quartile_range"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.inner_quartile_range" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.load">
<span class="sig-name descname"><span class="pre">load</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">interface</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="#birdshot.birdshot.Birdshot" title="birdshot.birdshot.Birdshot"><span class="pre">Birdshot</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.load"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.load" title="Link to this definition">¶</a></dt>
<dd><p>Load the contents of a file as properties into an entry. At present
only JSON-formatted content is supported.</p>
<p>We know we’re in Google Drive, so rely on the metadata present in
the Google Drive query.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>agent</strong> (<a class="reference internal" href="#birdshot.birdshot.Birdshot" title="birdshot.birdshot.Birdshot"><em>Birdshot</em></a>) – Althought a class nested within the Birdshot class, the Entry
class does not have access to member variables in Birdshot.
Therefore, <cite>load</cite> must be passed an agent to mediate
communication with Google Drive.</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>None</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.mean">
<span class="sig-name descname"><span class="pre">mean</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.mean"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.mean" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.median">
<span class="sig-name descname"><span class="pre">median</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.median"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.median" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.mode">
<span class="sig-name descname"><span class="pre">mode</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.mode"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.mode" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.model_config">
<span class="sig-name descname"><span class="pre">model_config</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">ClassVar</span><span class="p"><span class="pre">[</span></span><span class="pre">ConfigDict</span><span class="p"><span class="pre">]</span></span></em><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{}</span></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.model_config" title="Link to this definition">¶</a></dt>
<dd><p>Configuration for the model, should be a dictionary conforming to [<cite>ConfigDict</cite>][pydantic.config.ConfigDict].</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.model_fields">
<span class="sig-name descname"><span class="pre">model_fields</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">ClassVar</span><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#dict" title="(in Python v3.11)"><span class="pre">dict</span></a><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">FieldInfo</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></em><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{'id':</span> <span class="pre">FieldInfo(annotation=Union[str,</span> <span class="pre">NoneType],</span> <span class="pre">required=False),</span> <span class="pre">'metadata':</span> <span class="pre">FieldInfo(annotation=Dict[str,</span> <span class="pre">Any],</span> <span class="pre">required=False,</span> <span class="pre">default={}),</span> <span class="pre">'properties':</span> <span class="pre">FieldInfo(annotation=dict[str,</span> <span class="pre">set[Birdshot.Property]],</span> <span class="pre">required=False,</span> <span class="pre">default_factory=&lt;lambda&gt;)}</span></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.model_fields" title="Link to this definition">¶</a></dt>
<dd><p>Metadata about the fields defined on the model,
mapping of field names to [<cite>FieldInfo</cite>][pydantic.fields.FieldInfo].</p>
<p>This replaces <cite>Model.__fields__</cite> from Pydantic V1.</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.properties">
<span class="sig-name descname"><span class="pre">properties</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#dict" title="(in Python v3.11)"><span class="pre">dict</span></a><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#set" title="(in Python v3.11)"><span class="pre">set</span></a><span class="p"><span class="pre">[</span></span><a class="reference internal" href="#birdshot.birdshot.Birdshot.Property" title="birdshot.birdshot.Birdshot.Property"><span class="pre">Birdshot.Property</span></a><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.properties" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.serialize_properties">
<span class="sig-name descname"><span class="pre">serialize_properties</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">prop</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#dict" title="(in Python v3.11)"><span class="pre">dict</span></a><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#set" title="(in Python v3.11)"><span class="pre">set</span></a><span class="p"><span class="pre">[</span></span><a class="reference internal" href="#birdshot.birdshot.Birdshot.Property" title="birdshot.birdshot.Birdshot.Property"><span class="pre">Property</span></a><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">_info</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.serialize_properties"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.serialize_properties" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.std">
<span class="sig-name descname"><span class="pre">std</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.std"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.std" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Entry.variance">
<span class="sig-name descname"><span class="pre">variance</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Entry.variance"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Entry.variance" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.G">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">G</span></span><a class="headerlink" href="#birdshot.birdshot.Birdshot.G" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Property">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">Property</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">value</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Any" title="(in Python v3.11)"><span class="pre">Any</span></a></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.Property"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.Property" title="Link to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal notranslate"><span class="pre">BaseModel</span></code>, <a class="reference external" href="https://docs.python.org/3.11/library/collections.abc.html#collections.abc.Hashable" title="(in Python v3.11)"><code class="xref py py-class docutils literal notranslate"><span class="pre">Hashable</span></code></a></p>
<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Property.id">
<span class="sig-name descname"><span class="pre">id</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Property.id" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Property.model_config">
<span class="sig-name descname"><span class="pre">model_config</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">ClassVar</span><span class="p"><span class="pre">[</span></span><span class="pre">ConfigDict</span><span class="p"><span class="pre">]</span></span></em><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{}</span></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Property.model_config" title="Link to this definition">¶</a></dt>
<dd><p>Configuration for the model, should be a dictionary conforming to [<cite>ConfigDict</cite>][pydantic.config.ConfigDict].</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Property.model_fields">
<span class="sig-name descname"><span class="pre">model_fields</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">ClassVar</span><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#dict" title="(in Python v3.11)"><span class="pre">dict</span></a><span class="p"><span class="pre">[</span></span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">FieldInfo</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></em><em class="property"><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="pre">{'id':</span> <span class="pre">FieldInfo(annotation=str,</span> <span class="pre">required=False,</span> <span class="pre">default_factory=&lt;lambda&gt;),</span> <span class="pre">'name':</span> <span class="pre">FieldInfo(annotation=str,</span> <span class="pre">required=True),</span> <span class="pre">'value':</span> <span class="pre">FieldInfo(annotation=Any,</span> <span class="pre">required=True)}</span></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Property.model_fields" title="Link to this definition">¶</a></dt>
<dd><p>Metadata about the fields defined on the model,
mapping of field names to [<cite>FieldInfo</cite>][pydantic.fields.FieldInfo].</p>
<p>This replaces <cite>Model.__fields__</cite> from Pydantic V1.</p>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Property.name">
<span class="sig-name descname"><span class="pre">name</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Property.name" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.Property.value">
<span class="sig-name descname"><span class="pre">value</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">Any</span></em><a class="headerlink" href="#birdshot.birdshot.Birdshot.Property.value" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.build_graph">
<span class="sig-name descname"><span class="pre">build_graph</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">rootId</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.build_graph"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.build_graph" title="Link to this definition">¶</a></dt>
<dd><p>Google Drive exposes a list function that is much faster than
iterating through nodes sequentially.</p>
<p>Note: This method does not change the state of the instance but,
instead, is intended to build graphs from a given node ID. If you want
to set the graph available in an instance graph, see
<cite>Birdshot.graph(nodeId)</cite>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>rootId</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><em>str</em></a>) – File ID of the root node in the graph. If not given, this is the
project connection root</p>
</dd>
</dl>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.connection">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">connection</span></span><a class="headerlink" href="#birdshot.birdshot.Birdshot.connection" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.graph">
<span class="sig-name descname"><span class="pre">graph</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fileId</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/pathlib.html#pathlib.Path" title="(in Python v3.11)"><span class="pre">Path</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference internal" href="#birdshot.birdshot.Birdshot.Entry" title="birdshot.birdshot.Birdshot.Entry"><span class="pre">Entry</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">DiGraph</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><a class="reference external" href="https://docs.python.org/3.11/library/constants.html#None" title="(in Python v3.11)"><span class="pre">None</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">DiGraph</span></span></span><a class="reference internal" href="../_modules/birdshot/birdshot.html#Birdshot.graph"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.birdshot.Birdshot.graph" title="Link to this definition">¶</a></dt>
<dd><p>Within Google Drive it is easier to build the graph by retrieving all
available nodes and building the graph from the specified root.</p>
<p>If <cite>fileId</cite> is given, this forces a rebuild of the graph. Therefore, to
force a rebuild of the project graph:</p>
<blockquote>
<div><p>birdshot = Birdshot(&lt;username&gt;, &lt;password&gt;)
…
birdshot.graph(birdshot.root.id)</p>
</div></blockquote>
<p>To access the graph itself, use <cite>birdshot.G</cite> (<cite>birdshot</cite> is a
<cite>Birdshot</cite> instance, as above).</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>fileId</strong> (<a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><em>str</em></a><em> | </em><em>Path</em><em> | </em><a class="reference internal" href="#birdshot.birdshot.Birdshot.Entry" title="birdshot.birdshot.Birdshot.Entry"><em>Birdshot.Entry</em></a>) – The root node. If not specified, use the root node for this project
connection.</p></li>
<li><p><strong>graph</strong> (<em>networkx.DiGraph</em>) – Unnecessary in this function. Kept here to maintain API
compatibility with the base class.</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>The graph of the resource structure.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>networkx.DiGraph</p>
</dd>
</dl>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.project">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">project</span></span><a class="headerlink" href="#birdshot.birdshot.Birdshot.project" title="Link to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="birdshot.birdshot.Birdshot.root">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">root</span></span><a class="headerlink" href="#birdshot.birdshot.Birdshot.root" title="Link to this definition">¶</a></dt>
<dd><p>Root node of the current graph.</p>
<p>Note: this is the node document retrieved from Google and structured
as a Node. The ID (e.g., “nativeId”) of this node can be retrieved as
<cite>&lt;Birdshot instance&gt;.root.id</cite>.</p>
</dd></dl>

</dd></dl>

</section>
<section id="module-birdshot.cli">
<span id="birdshot-cli-module"></span><h2>birdshot.cli module<a class="headerlink" href="#module-birdshot.cli" title="Link to this heading">¶</a></h2>
<p>BIRDSHOT project actions.</p>
<dl class="py class">
<dt class="sig sig-object py" id="birdshot.cli.Storage">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">birdshot.cli.</span></span><span class="sig-name descname"><span class="pre">Storage</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">username</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">password</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">url</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">*</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">skip_validation</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/functions.html#bool" title="(in Python v3.11)"><span class="pre">bool</span></a></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/cli.html#Storage"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.cli.Storage" title="Link to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3.11/library/functions.html#object" title="(in Python v3.11)"><code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></a></p>
</dd></dl>

<dl class="py exception">
<dt class="sig sig-object py" id="birdshot.cli.UserNotFoundError">
<em class="property"><span class="pre">exception</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">birdshot.cli.</span></span><span class="sig-name descname"><span class="pre">UserNotFoundError</span></span><a class="reference internal" href="../_modules/birdshot/cli.html#UserNotFoundError"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.cli.UserNotFoundError" title="Link to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3.11/library/exceptions.html#Exception" title="(in Python v3.11)"><code class="xref py py-class docutils literal notranslate"><span class="pre">Exception</span></code></a></p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.cli.process_commands">
<span class="sig-prename descclassname"><span class="pre">birdshot.cli.</span></span><span class="sig-name descname"><span class="pre">process_commands</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">processors</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwds</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/cli.html#process_commands"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.cli.process_commands" title="Link to this definition">¶</a></dt>
<dd><p>This result callback is invoked with an iterable of all the chained
subcommands.  Each subcommand returns a function that is chained together
to feed one into the other, similar to how a pipe on unix works.</p>
</dd></dl>

</section>
<section id="module-birdshot.operations">
<span id="birdshot-operations-module"></span><h2>birdshot.operations module<a class="headerlink" href="#module-birdshot.operations" title="Link to this heading">¶</a></h2>
<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.aggregate">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">aggregate</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">algorithm</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">method</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">start</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">stop</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#aggregate"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.aggregate" title="Link to this definition">¶</a></dt>
<dd><p>Aggregate data from the leaf node toward the root. (Data flow:
successor -&gt; predecessor.) This is done in place.</p>
<p>Two algorithms are available: postorder (default) and preorder. In
postorder traveral properties are passed from leaf nodes through to all
predecessors (collect). In preorder traversal, properties are passed
only to the immediate predecessor of each node (nearest).</p>
<p>If there is no path to a root node from a leaf, the leaf’s properties are
aggregated to its root, even if that root does not match “start”.</p>
<p>This operation does not consume any objects. All objects are returned to
the stream once the aggregation is complete. This operation only acts upon
directed graphs.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.all_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">all_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#all_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.all_" title="Link to this definition">¶</a></dt>
<dd><p>Returns True if all enqueued values are True.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.any_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">any_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#any_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.any_" title="Link to this definition">¶</a></dt>
<dd><p>Returns True if any enqueued value is True.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.apply">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">apply</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">func</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">params</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#apply"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.apply" title="Link to this definition">¶</a></dt>
<dd><p>For each iterable-like entry in the stream, apply the named function to
each element in that iterable.</p>
<p>Function parameters must be passed through the <cite>params</cite> option. The
required arguments to each function can be found in the “help” of the
function.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.bool_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">bool_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#bool_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.bool_" title="Link to this definition">¶</a></dt>
<dd><p>Cast each object as a boolean.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.children">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">children</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#children"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.children" title="Link to this definition">¶</a></dt>
<dd><p>Return the children nodes of each Birdshot.Entry node.</p>
<p>If none, returns an empty list.</p>
<p>Warning: All non-node objects are discarded.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.dict_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">dict_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#dict_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.dict_" title="Link to this definition">¶</a></dt>
<dd><p>Typically used in conjunction with <cite>pop –zip</cite>, this generates a dictionary
from a list of tuples.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.download">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">download</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">filename</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dest</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#download"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.download" title="Link to this definition">¶</a></dt>
<dd><p>Download the files associated with the Birdshot.Entry nodes.</p>
<p>If specified, a FILENAME may be provided as a default. If not specified the
files are saved to &lt;node.name&gt;-&lt;node.id&gt;.&lt;node.suffix&gt;. For example, for a
node named “foo.txt” with id = “1234”, the file will be saved to
“foo-1234.txt”.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.drop">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">drop</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#drop"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.drop" title="Link to this definition">¶</a></dt>
<dd><p>Drop all objects from the queue.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.dump">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">dump</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">prefix</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">error</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">params</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#dump"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.dump" title="Link to this definition">¶</a></dt>
<dd><p>Dumps the objects in the queue to archives. This attempts to write first to
the more restrictive, but more ubiquitous, JSON archive and, if that fails,
to the more general python pickle archive.</p>
<p>Objects are consumed on dump, so if you wish to continue working on working
with objects after they are saved, be sure to save them (push/pop) before
writing.</p>
<p>## JSON Parameters</p>
<dl class="simple">
<dt></dt><dd><p>skipkeys=False,
ensure_ascii=True,
check_circular=True,
allow_nan=True,
cls=None,
indent=None,
separators=None,
default=None,
sort_keys=False</p>
</dd>
</dl>
<p>## Pickle Parameters</p>
<dl class="simple">
<dt></dt><dd><p>protocol=None,
fix_imports=True,
buffer_callback=None,</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.dumps">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">dumps</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">error</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">params</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#dumps"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.dumps" title="Link to this definition">¶</a></dt>
<dd><p>Dumps the objects to the stdout in JSON format.</p>
<p>## Parameters</p>
<dl class="simple">
<dt></dt><dd><p>skipkeys=False,
ensure_ascii=True,
check_circular=True,
allow_nan=True,
cls=None,
indent=None,
separators=None,
default=None,
sort_keys=False</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.field">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">field</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">field</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">missing</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#field"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.field" title="Link to this definition">¶</a></dt>
<dd><p>Extracts a field (obj.&lt;FIELD&gt;) from each object in the stream.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.get">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">get</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">index</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">missing</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#get"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.get" title="Link to this definition">¶</a></dt>
<dd><p>Extracts a key (obj[&lt;KEY&gt;]) from each object in the stream.</p>
<p>If not one of {exit, pass, skip, or stop}, a literal evaluation of the
value is passed as the default, e.g. ‘–missing None’</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.graph">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">graph</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#graph"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.graph" title="Link to this definition">¶</a></dt>
<dd><p>Returns, and if necessary constructs from Google Drive, a graph of the
BIRDSHOT data/filesystem.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.iter_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">iter_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#iter_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.iter_" title="Link to this definition">¶</a></dt>
<dd><p>Iterates through stream objects that are iterable. Stream objects that are
not iterable are passed through unaltered.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.len_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">len_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#len_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.len_" title="Link to this definition">¶</a></dt>
<dd><p>Writes the length of the stream to the stdout.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.list_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">list_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#list_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.list_" title="Link to this definition">¶</a></dt>
<dd><p>Convert the stream into a list.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.load">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">load</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">input</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#load"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.load" title="Link to this definition">¶</a></dt>
<dd><p>Loads either a JSON or python pickle archive, based on the filename prefix.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.match">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">match</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pattern</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ignore_case</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">missing</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#match"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.match" title="Link to this definition">¶</a></dt>
<dd><p>Performs a regular expression match between objects, treating the result as
boolean.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.model_dump">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">model_dump</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#model_dump"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.model_dump" title="Link to this definition">¶</a></dt>
<dd><p>Converts pydantic BaseModel-like objects to JSON. Other objects are
returned unaltered.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.node_filter">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">node_filter</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">id</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#node_filter"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.node_filter" title="Link to this definition">¶</a></dt>
<dd><p>Search the BIRDSHOT Google Drive for entries matching the specified
pattern. All patterns are interpreted as regular expressions.</p>
<p>If multiple patterns are specified, the results are logically OR’ed. For
example:</p>
<dl class="simple">
<dt></dt><dd><dl class="simple">
<dt>birdshot graph nodes </dt><dd><p>iter filter-records -n “.*.json” -“.*.txt” filter-records -n “foo.*”</p>
</dd>
</dl>
</dd>
</dl>
<p>will return all records matching (‘.*.json’ or ‘.*.txt’) and (‘foo.*’),
i.e. any records with names matching ‘foo.*.(json|txt)’.</p>
<p>That is, arguments within a single filter command ‘OR’, subsequent filter
commands ‘AND’.</p>
<p>All objects that are not records are dropped.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.nodes">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">nodes</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#nodes"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.nodes" title="Link to this definition">¶</a></dt>
<dd><p>Accesses the nodes from a stream.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.parents">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">parents</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#parents"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.parents" title="Link to this definition">¶</a></dt>
<dd><p>Returns the parent folder(s) of each Birdshot.Entry node.</p>
<p>If no parents are present, an empty list is returned.</p>
<p>Note: Non-node entries in the stream are discarded.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.path">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">path</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#path"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.path" title="Link to this definition">¶</a></dt>
<dd><p>Returns the path to each Birdshot.Entry record. Multiple paths are not
supported.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.pop">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">pop</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">index</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">zip_</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">reverse</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#pop"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.pop" title="Link to this definition">¶</a></dt>
<dd><p>Adds the last set of objects pushed onto the stack. This is used in
conjunction with <cite>push</cite> to temporarily store data for later processing.</p>
<p>By default, the existing arguments are returned before the arguments popped
from the stack. This can be reversed using the ‘-r/–reverse’ flag.</p>
<p>Existing and stack arguments can be zipped together (‘-z/–zip’ flag).
Multiple calls to <cite>pop</cite> with construct an increasingly large tuple. For
example:</p>
<dl class="option-list">
<dt><kbd><span class="option">/b</span></kbd></dt>
<dd><dl class="simple">
<dt>birdshot graph # gets the BIRDSHOT graph</dt><dd><p>field nodes # gets the graph nodes iterator object
iter # iterates through the nodes
push –pass # pushes the nodes onto the stack for now and later
field name # gets the name field from each node
push # stores names in the stack for later
pop –index 0 # pops the nodes off the stack
field id # gets the id field from each node
pop –zip # zips id and name into  (id, name) pairs.</p>
</dd>
</dl>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.propagate">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">propagate</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">algorithm</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">method</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">start</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">stop</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#propagate"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.propagate" title="Link to this definition">¶</a></dt>
<dd><p>Propagates data towards leaf nodes. (Data flow: predecessor -&gt; successor.)
This is done in place.</p>
<p>Two algorithms are available: preorder (default) and postorder. In preorder
traveral properties are passed from root node through to all descendents
(scatter). In postodrer traversal, properties are passed only to the
immediate successor of each node (nearest).</p>
<p>If there is no path to a leaf node from a root, the root’s properties are
propagated to the terminal nodes.</p>
<p>This operation does not consume any objects. All objects are returned to
the stream once the aggregation is complete. This operation only acts upon
directed graphs.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.push">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">push</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pass_</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#push"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.push" title="Link to this definition">¶</a></dt>
<dd><p>Pushes the objects onto the stack for future use.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.reduce">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">reduce</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cast</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">func</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">include</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">exclude</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">replace</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">suffix</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#reduce"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.reduce" title="Link to this definition">¶</a></dt>
<dd><p>Perform one or more reductions on node properties.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.replace">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">replace</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">old</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">new</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#replace"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.replace" title="Link to this definition">¶</a></dt>
<dd><p>Replace all occurances of &lt;OLD&gt; with &lt;NEW&gt;.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.store">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">store</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">key</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">squeeze</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#store"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.store" title="Link to this definition">¶</a></dt>
<dd><p>Store the arguments for future, keyed access.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.str_">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">str_</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#str_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.str_" title="Link to this definition">¶</a></dt>
<dd><p>Cast each object as a string.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.strip">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">strip</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">chars</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#strip"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.strip" title="Link to this definition">¶</a></dt>
<dd><p>Strips the chars from the front and back of strings.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.tabulate">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">tabulate</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#tabulate"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.tabulate" title="Link to this definition">¶</a></dt>
<dd><p>Converts a graph to a DataFrame. This consumes all objects in the stream.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.to_csv">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">to_csv</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">filename</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">params</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#to_csv"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.to_csv" title="Link to this definition">¶</a></dt>
<dd><p>Write all dataframes and graphs/nodes to CSV.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong></strong> – <dl>
<dt>sep<span class="classifier">str, default ‘,’</span></dt><dd><p>String of length 1. Field delimiter for the output file.</p>
</dd>
<dt>na_rep<span class="classifier">str, default ‘’</span></dt><dd><p>Missing data representation.</p>
</dd>
<dt>float_format<span class="classifier">str, Callable, default None</span></dt><dd><p>Format string for floating point numbers. If a Callable is given, it takes
precedence over other numeric formatting parameters, like decimal.</p>
</dd>
<dt>columns<span class="classifier">sequence, optional</span></dt><dd><p>Columns to write.</p>
</dd>
<dt>header<span class="classifier">bool or list of str, default True</span></dt><dd><p>Write out the column names. If a list of strings is given it is
assumed to be aliases for the column names.</p>
</dd>
<dt>index<span class="classifier">bool, default True</span></dt><dd><p>Write row names (index).</p>
</dd>
<dt>index_label<span class="classifier">str or sequence, or False, default None</span></dt><dd><p>Column label for index column(s) if desired. If None is given, and
<cite>header</cite> and <cite>index</cite> are True, then the index names are used. A
sequence should be given if the object uses MultiIndex. If
False do not print fields for index names. Use index_label=False
for easier importing in R.</p>
</dd>
<dt>mode<span class="classifier">{‘w’, ‘x’, ‘a’}, default ‘w’</span></dt><dd><p>Forwarded to either <cite>open(mode=)</cite> or <cite>fsspec.open(mode=)</cite> to control
the file opening. Typical values include:</p>
<ul class="simple">
<li><p>’w’, truncate the file first.</p></li>
<li><p>’x’, exclusive creation, failing if the file already exists.</p></li>
<li><p>’a’, append to the end of file if it exists.</p></li>
</ul>
</dd>
<dt>encoding<span class="classifier">str, optional</span></dt><dd><p>A string representing the encoding to use in the output file,
defaults to ‘utf-8’. <cite>encoding</cite> is not supported if <cite>path_or_buf</cite>
is a non-binary file object.</p>
</dd>
<dt>compression<span class="classifier">str or dict, default ‘infer’</span></dt><dd><p>For on-the-fly compression of the output data. If ‘infer’ and ‘path_or_buf’ is
path-like, then detect compression from the following extensions: ‘.gz’,
‘.bz2’, ‘.zip’, ‘.xz’, ‘.zst’, ‘.tar’, ‘.tar.gz’, ‘.tar.xz’ or ‘.tar.bz2’
(otherwise no compression).
Set to <code class="docutils literal notranslate"><span class="pre">None</span></code> for no compression.
Can also be a dict with key <code class="docutils literal notranslate"><span class="pre">'method'</span></code> set
to one of {<code class="docutils literal notranslate"><span class="pre">'zip'</span></code>, <code class="docutils literal notranslate"><span class="pre">'gzip'</span></code>, <code class="docutils literal notranslate"><span class="pre">'bz2'</span></code>, <code class="docutils literal notranslate"><span class="pre">'zstd'</span></code>, <code class="docutils literal notranslate"><span class="pre">'xz'</span></code>, <code class="docutils literal notranslate"><span class="pre">'tar'</span></code>} and
other key-value pairs are forwarded to
<code class="docutils literal notranslate"><span class="pre">zipfile.ZipFile</span></code>, <code class="docutils literal notranslate"><span class="pre">gzip.GzipFile</span></code>,
<code class="docutils literal notranslate"><span class="pre">bz2.BZ2File</span></code>, <code class="docutils literal notranslate"><span class="pre">zstandard.ZstdCompressor</span></code>, <code class="docutils literal notranslate"><span class="pre">lzma.LZMAFile</span></code> or
<code class="docutils literal notranslate"><span class="pre">tarfile.TarFile</span></code>, respectively.
As an example, the following could be passed for faster compression and to create
a reproducible gzip archive:
<code class="docutils literal notranslate"><span class="pre">compression={'method':</span> <span class="pre">'gzip',</span> <span class="pre">'compresslevel':</span> <span class="pre">1,</span> <span class="pre">'mtime':</span> <span class="pre">1}</span></code>.</p>
<div class="versionadded">
<p><span class="versionmodified added">New in version 1.5.0: </span>Added support for <cite>.tar</cite> files.</p>
</div>
<p>May be a dict with key ‘method’ as compression mode
and other entries as additional compression options if
compression mode is ‘zip’.</p>
<p>Passing compression options as keys in dict is
supported for compression modes ‘gzip’, ‘bz2’, ‘zstd’, and ‘zip’.</p>
<div class="versionchanged">
<p><span class="versionmodified changed">Changed in version 1.2.0: </span>Compression is supported for binary file objects.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified changed">Changed in version 1.2.0: </span>Previous versions forwarded dict entries for ‘gzip’ to
<cite>gzip.open</cite> instead of <cite>gzip.GzipFile</cite> which prevented
setting <cite>mtime</cite>.</p>
</div>
</dd>
<dt>quoting<span class="classifier">optional constant from csv module</span></dt><dd><p>Defaults to csv.QUOTE_MINIMAL. If you have set a <cite>float_format</cite>
then floats are converted to strings and thus csv.QUOTE_NONNUMERIC
will treat them as non-numeric.</p>
</dd>
<dt>quotechar<span class="classifier">str, default ‘”’</span></dt><dd><p>String of length 1. Character used to quote fields.</p>
</dd>
<dt>lineterminator<span class="classifier">str, optional</span></dt><dd><p>The newline character or character sequence to use in the output
file. Defaults to <cite>os.linesep</cite>, which depends on the OS in which
this method is called (’n’ for linux, ‘rn’ for Windows, i.e.).</p>
<div class="versionchanged">
<p><span class="versionmodified changed">Changed in version 1.5.0: </span>Previously was line_terminator, changed for consistency with
read_csv and the standard library ‘csv’ module.</p>
</div>
</dd>
<dt>chunksize<span class="classifier">int or None</span></dt><dd><p>Rows to write at a time.</p>
</dd>
<dt>date_format<span class="classifier">str, default None</span></dt><dd><p>Format string for datetime objects.</p>
</dd>
<dt>doublequote<span class="classifier">bool, default True</span></dt><dd><p>Control quoting of <cite>quotechar</cite> inside a field.</p>
</dd>
<dt>escapechar<span class="classifier">str, default None</span></dt><dd><p>String of length 1. Character used to escape <cite>sep</cite> and <cite>quotechar</cite>
when appropriate.</p>
</dd>
<dt>decimal<span class="classifier">str, default ‘.’</span></dt><dd><p>Character recognized as decimal separator. E.g. use ‘,’ for
European data.</p>
</dd>
<dt>errors<span class="classifier">str, default ‘strict’</span></dt><dd><p>Specifies how encoding and decoding errors are to be handled.
See the errors argument for <a class="reference external" href="https://docs.python.org/3.11/library/functions.html#open" title="(in Python v3.11)"><code class="xref py py-func docutils literal notranslate"><span class="pre">open()</span></code></a> for a full list
of options.</p>
</dd>
<dt>storage_options<span class="classifier">dict, optional</span></dt><dd><p>Extra options that make sense for a particular storage connection, e.g.
host, port, username, password, etc. For HTTP(S) URLs the key-value pairs
are forwarded to <code class="docutils literal notranslate"><span class="pre">urllib.request.Request</span></code> as header options. For other
URLs (e.g. starting with “s3://”, and “gcs://”) the key-value pairs are
forwarded to <code class="docutils literal notranslate"><span class="pre">fsspec.open</span></code>. Please see <code class="docutils literal notranslate"><span class="pre">fsspec</span></code> and <code class="docutils literal notranslate"><span class="pre">urllib</span></code> for more
details, and for more examples on storage options refer <a class="reference external" href="https://pandas.pydata.org/docs/user_guide/io.html?highlight=storage_options#reading-writing-remote-files">here</a>.</p>
<div class="versionadded">
<p><span class="versionmodified added">New in version 1.2.0.</span></p>
</div>
</dd>
</dl>
</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.unpack">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">unpack</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#unpack"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.unpack" title="Link to this definition">¶</a></dt>
<dd><p>Load contents from the backend data store as node properties.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.operations.where">
<span class="sig-prename descclassname"><span class="pre">birdshot.operations.</span></span><span class="sig-name descname"><span class="pre">where</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">storage</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">objs</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">store</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">index</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">push</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/operations.html#where"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.operations.where" title="Link to this definition">¶</a></dt>
<dd><p>Select objects masked by the variable in “store” or the stack. By default
the last entry in the stack is used. The shorter of mask and stream
dictates the length of the output.</p>
</dd></dl>

</section>
<section id="module-birdshot.pipe">
<span id="birdshot-pipe-module"></span><h2>birdshot.pipe module<a class="headerlink" href="#module-birdshot.pipe" title="Link to this heading">¶</a></h2>
<dl class="py function">
<dt class="sig sig-object py" id="birdshot.pipe.generator">
<span class="sig-prename descclassname"><span class="pre">birdshot.pipe.</span></span><span class="sig-name descname"><span class="pre">generator</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">f</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/pipe.html#generator"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.pipe.generator" title="Link to this definition">¶</a></dt>
<dd><p>Creates a generator from a function.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.pipe.params_to_dict">
<span class="sig-prename descclassname"><span class="pre">birdshot.pipe.</span></span><span class="sig-name descname"><span class="pre">params_to_dict</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">arg</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference external" href="https://docs.python.org/3.11/library/stdtypes.html#str" title="(in Python v3.11)"><span class="pre">str</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference external" href="https://docs.python.org/3.11/library/typing.html#typing.Dict" title="(in Python v3.11)"><span class="pre">Dict</span></a></span></span><a class="reference internal" href="../_modules/birdshot/pipe.html#params_to_dict"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.pipe.params_to_dict" title="Link to this definition">¶</a></dt>
<dd><p>Parse a string of the form “param1=value1|param2=value2|…” into a dict.</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="birdshot.pipe.processor">
<span class="sig-prename descclassname"><span class="pre">birdshot.pipe.</span></span><span class="sig-name descname"><span class="pre">processor</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">f</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/birdshot/pipe.html#processor"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#birdshot.pipe.processor" title="Link to this definition">¶</a></dt>
<dd><p>Creates a processor from a function.</p>
</dd></dl>

</section>
<section id="module-birdshot">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-birdshot" title="Link to this heading">¶</a></h2>
</section>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">birdshot</a></h1>








<h3>Navigation</h3>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../cli.html">CLI</a></li>
<li class="toctree-l1"><a class="reference internal" href="../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../changelog.html">Changelog</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="modules.html">Module Reference</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#">birdshot package</a></li>
</ul>
</li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
  <li><a href="modules.html">birdshot</a><ul>
      <li>Previous: <a href="modules.html" title="previous chapter">birdshot</a></li>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize LLC.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
      |
      <a href="../_sources/api/birdshot.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>